#include <dlfcn.h>
#include <stdio.h>

#include <errno.h>
#include "wrg315api.h"

GET_DEVICE_LIST GetDeviceList=NULL;
DESTROY_DEVICE_LIST DestroyDeviceList=NULL;
OPEN_DEVICE OpenDevice=NULL;
CLOSE_DEVICE CloseDevice=NULL;
GET_DEVICE_INFO GetDeviceInfo=NULL;
GET_POWER GetPower=NULL;
SET_POWER SetPower=NULL;
GET_FREQUENCY GetFrequency=NULL;
SET_FREQUENCY SetFrequency=NULL;
GET_VOLUME GetVolume=NULL;
SET_VOLUME SetVolume=NULL;
GET_MODE GetMode=NULL;
SET_MODE SetMode=NULL;
SET_AUDIO_CALLBACK SetAudioCallback=NULL;
SET_IF_CALLBACK SetIFCallback=NULL;
SET_IF_SPECTRUM_CALLBACK SetIFSpectrumCallback=NULL;
GET_IF_SHIFT GetIFShift=NULL;
SET_IF_SHIFT SetIFShift=NULL;
GET_IF_BANDWIDTH GetIFBandwidth=NULL;
SET_IF_BANDWIDTH SetIFBandwidth=NULL;
GET_AGC GetAGC=NULL;
SET_AGC SetAGC=NULL;
GET_IF_GAIN GetIFGain=NULL;
SET_IF_GAIN SetIFGain=NULL;
ENABLE_AUDIO_FILTER EnableAudioFilter=NULL;
GET_AUDIO_FILTER GetAudioFilter=NULL;
SET_AUDIO_FILTER SetAudioFilter=NULL;
GET_SOFT_AGC GetSoftAGC=NULL;
SET_SOFT_AGC SetSoftAGC=NULL;
GET_NOTCH_FILTER GetNotchFilter=NULL;
SET_NOTCH_FILTER SetNotchFilter=NULL;
ENABLE_NOTCH_FILTER EnableNotchFilter=NULL;
GET_NOISE_BLANKER GetNoiseBlanker=NULL;
SET_NOISE_BLANKER SetNoiseBlanker=NULL;
LOAD_CALIBRATION_FILE LoadCalibrationFile=NULL;
UNLOAD_CALIBRATION_FILE UnloadCalibrationFile=NULL;
GET_ATTENUATOR GetAttenuator=NULL;
SET_ATTENUATOR SetAttenuator=NULL;
GET_RF_AMPLIFIER GetRFAmplifier=NULL;
SET_RF_AMPLIFIER SetRFAmplifier=NULL;
GET_INTERNAL_RSSI GetInternalRSSI=NULL;
GET_RAW_SIGNAL_STRENGTH GetRawSignalStrength=NULL;
GET_SIGNAL_STRENGTH_DBM GetSignalStrengthdBm=NULL;
GET_REF_CLOCK GetRefClock=NULL;
SET_REF_CLOCK SetRefClock=NULL;
STOP_SCANNING StopScanning=NULL;
START_SCANNING StartScanning=NULL;
GET_FRONT_PANEL_LED GetFrontPanelLED=NULL;
SET_FRONT_PANEL_LED SetFrontPanelLED=NULL;
IS_DEVICE_CONNECTED IsDeviceConnected=NULL;
GET_AUDIO_GAIN GetAudioGain=NULL;
SET_AUDIO_GAIN SetAudioGain=NULL;
GET_FMAF_SQUELCH_LEVEL GetFMAFSquelchLevel=NULL;
SET_FMAF_SQUELCH_LEVEL SetFMAFSquelchLevel=NULL;
GET_ISB_AUDIO_CHANNEL GetISBAudioChannel=NULL;
SET_ISB_AUDIO_CHANNEL SetISBAudioChannel=NULL;
GET_CW_TONE GetCWTone=NULL;
SET_CW_TONE SetCWTone=NULL;
GET_STATISTICS GetStatistics=NULL;
GET_API_VERSION GetAPIVersion=NULL;

void *hWRG315API=0;

#define GET_PROC(t,f)               \
    f=(t)dlsym(hWRG315API,"" #f);   \
    if(f==NULL)                     \
    {                               \
                                    \
        fprintf(stderr,"Unable to load valid "WRG3APINAME" library.\n"); \
        fprintf(stderr,"Unable to find " #f " procedure.\n");\
        dlclose(hWRG315API);        \
        hWRG315API=NULL;            \
        return 0;                   \
    }


int InitAPI(void)
{
    if(hWRG315API)
    {
        return 1;
    }
    else
    {
        hWRG315API=dlopen("wrg315api.so",RTLD_LAZY);

        if(hWRG315API==NULL)
        {
            fprintf(stderr,"Unable to load "WRG3APINAME" shared library  (%s).\n",dlerror());
            return 0;
        }
        else
        {
            GET_PROC(GET_DEVICE_LIST,GetDeviceList)
            GET_PROC(DESTROY_DEVICE_LIST,DestroyDeviceList)
            GET_PROC(OPEN_DEVICE,OpenDevice)
            GET_PROC(CLOSE_DEVICE,CloseDevice)
            GET_PROC(GET_DEVICE_INFO,GetDeviceInfo)
            GET_PROC(GET_POWER,GetPower)
            GET_PROC(SET_POWER,SetPower)
            GET_PROC(GET_FREQUENCY,GetFrequency)
            GET_PROC(SET_FREQUENCY,SetFrequency)
            GET_PROC(GET_VOLUME,GetVolume)
            GET_PROC(SET_VOLUME,SetVolume)
            GET_PROC(GET_MODE,GetMode)
            GET_PROC(SET_MODE,SetMode)
            GET_PROC(SET_AUDIO_CALLBACK,SetAudioCallback)
            GET_PROC(SET_IF_CALLBACK,SetIFCallback)
            GET_PROC(SET_IF_SPECTRUM_CALLBACK,SetIFSpectrumCallback)
            GET_PROC(GET_IF_SHIFT,GetIFShift)
            GET_PROC(SET_IF_SHIFT,SetIFShift)
            GET_PROC(GET_IF_BANDWIDTH,GetIFBandwidth)
            GET_PROC(SET_IF_BANDWIDTH,SetIFBandwidth)
            GET_PROC(GET_AGC,GetAGC)
            GET_PROC(SET_AGC,SetAGC)
            GET_PROC(GET_IF_GAIN,GetIFGain)
            GET_PROC(SET_IF_GAIN,SetIFGain)
            GET_PROC(ENABLE_AUDIO_FILTER,EnableAudioFilter)
            GET_PROC(GET_AUDIO_FILTER,GetAudioFilter)
            GET_PROC(SET_AUDIO_FILTER,SetAudioFilter)
            GET_PROC(GET_SOFT_AGC,GetSoftAGC)
            GET_PROC(SET_SOFT_AGC,SetSoftAGC)
            GET_PROC(GET_NOTCH_FILTER,GetNotchFilter)
            GET_PROC(SET_NOTCH_FILTER,SetNotchFilter)
            GET_PROC(ENABLE_NOTCH_FILTER,EnableNotchFilter)
            GET_PROC(GET_NOISE_BLANKER,GetNoiseBlanker)
            GET_PROC(SET_NOISE_BLANKER,SetNoiseBlanker)
            GET_PROC(LOAD_CALIBRATION_FILE,LoadCalibrationFile)
            GET_PROC(UNLOAD_CALIBRATION_FILE,UnloadCalibrationFile)
            GET_PROC(GET_ATTENUATOR,GetAttenuator)
            GET_PROC(SET_ATTENUATOR,SetAttenuator)
            GET_PROC(GET_RF_AMPLIFIER,GetRFAmplifier)
            GET_PROC(SET_RF_AMPLIFIER,SetRFAmplifier)
            GET_PROC(GET_INTERNAL_RSSI,GetInternalRSSI)
            GET_PROC(GET_RAW_SIGNAL_STRENGTH,GetRawSignalStrength)
            GET_PROC(GET_SIGNAL_STRENGTH_DBM,GetSignalStrengthdBm)
            GET_PROC(GET_REF_CLOCK,GetRefClock)
            GET_PROC(SET_REF_CLOCK,SetRefClock)
            GET_PROC(STOP_SCANNING,StopScanning)
            GET_PROC(START_SCANNING,StartScanning)
            GET_PROC(GET_FRONT_PANEL_LED,GetFrontPanelLED)
            GET_PROC(SET_FRONT_PANEL_LED,SetFrontPanelLED)
            GET_PROC(IS_DEVICE_CONNECTED,IsDeviceConnected)
            GET_PROC(GET_AUDIO_GAIN,GetAudioGain)
            GET_PROC(SET_AUDIO_GAIN,SetAudioGain)
            GET_PROC(GET_FMAF_SQUELCH_LEVEL,GetFMAFSquelchLevel)
            GET_PROC(SET_FMAF_SQUELCH_LEVEL,SetFMAFSquelchLevel)
            GET_PROC(GET_ISB_AUDIO_CHANNEL,GetISBAudioChannel)
            GET_PROC(SET_ISB_AUDIO_CHANNEL,SetISBAudioChannel)
            GET_PROC(GET_CW_TONE,GetCWTone)
            GET_PROC(SET_CW_TONE,SetCWTone)
            GET_PROC(GET_STATISTICS,GetStatistics)
            GET_PROC(GET_API_VERSION, GetAPIVersion)

            return 1;
        }
    }
}

void UninitAPI(void)
{
    if(hWRG315API)
    {
        dlclose(hWRG315API);
        hWRG315API=0;
    }
}

